package cz.zweistein.df.soundsense.output.sound.tts;

import java.util.LinkedList;
import java.util.Queue;
import java.util.logging.Logger;

import com.sun.speech.freetts.Voice;
import com.sun.speech.freetts.VoiceManager;

import cz.zweistein.df.soundsense.util.LoggerSource;

public class TextToSpeechThread implements Runnable {
	private static Logger logger = LoggerSource.logger;

	private Voice voice;
	
	private Queue<String> queue;

	public TextToSpeechThread() {
		this.queue = new LinkedList<String>();
		
        VoiceManager voiceManager = VoiceManager.getInstance();
        this.voice = voiceManager.getVoice("kevin16");
        this.voice.allocate();
	}

	public void play(String text) {
		this.queue.add(text);
	}

	@Override
	public void run() {
		while (true) {
			
			if (this.queue.size() > 0) {
				
				logger.finest("Speech queue has "+this.queue.size()+" items.");
				String text = this.queue.remove();
				logger.fine("Saying "+text);
				voice.speak(text);
				
			} else {
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {
				}
			}
				
			
		}
	}
	
	

}
